// dart format width=80
// GENERATED CODE - DO NOT MODIFY BY HAND

// **************************************************************************
// Generator: RxBlocGeneratorForAnnotation
// **************************************************************************

part of 'widgets.dart';

/// Used as a contractor for the bloc, events and states classes
/// @nodoc
abstract class EnhancedListViewBlocType extends RxBlocTypeBase {
  EnhancedListViewEvents get events;
  EnhancedListViewStates get states;
}

/// [$EnhancedListViewBloc<T, H, F>] extended by the [EnhancedListViewBloc<T, H, F>]
/// @nodoc
abstract class $EnhancedListViewBloc<T, H, F> extends RxBlocBase
    implements
        EnhancedListViewEvents,
        EnhancedListViewStates,
        EnhancedListViewBlocType {
  final _compositeSubscription = CompositeSubscription();

  /// Тhe [Subject] where events sink to by calling [loadBodyItems]
  final _$loadBodyItemsEvent = PublishSubject<bool>();

  /// Тhe [Subject] where events sink to by calling [loadHeaderItems]
  final _$loadHeaderItemsEvent = PublishSubject<void>();

  /// Тhe [Subject] where events sink to by calling [loadFooterItems]
  final _$loadFooterItemsEvent = PublishSubject<void>();

  /// The state of [bodyItems] implemented in [_mapToBodyItemsState]
  late final Stream<List<T>> _bodyItemsState = _mapToBodyItemsState();

  /// The state of [headerItems] implemented in [_mapToHeaderItemsState]
  late final Stream<List<H>> _headerItemsState = _mapToHeaderItemsState();

  /// The state of [footerItems] implemented in [_mapToFooterItemsState]
  late final Stream<List<F>> _footerItemsState = _mapToFooterItemsState();

  /// The state of [isLoading] implemented in [_mapToIsLoadingState]
  late final Stream<bool> _isLoadingState = _mapToIsLoadingState();

  /// The state of [errors] implemented in [_mapToErrorsState]
  late final Stream<String> _errorsState = _mapToErrorsState();

  @override
  void loadBodyItems({bool reset = false}) => _$loadBodyItemsEvent.add(reset);

  @override
  void loadHeaderItems() => _$loadHeaderItemsEvent.add(null);

  @override
  void loadFooterItems() => _$loadFooterItemsEvent.add(null);

  @override
  Stream<List<T>> get bodyItems => _bodyItemsState;

  @override
  Stream<List<H>> get headerItems => _headerItemsState;

  @override
  Stream<List<F>> get footerItems => _footerItemsState;

  @override
  Stream<bool> get isLoading => _isLoadingState;

  @override
  Stream<String> get errors => _errorsState;

  Stream<List<T>> _mapToBodyItemsState();

  Stream<List<H>> _mapToHeaderItemsState();

  Stream<List<F>> _mapToFooterItemsState();

  Stream<bool> _mapToIsLoadingState();

  Stream<String> _mapToErrorsState();

  @override
  EnhancedListViewEvents get events => this;

  @override
  EnhancedListViewStates get states => this;

  @override
  void dispose() {
    _$loadBodyItemsEvent.close();
    _$loadHeaderItemsEvent.close();
    _$loadFooterItemsEvent.close();
    _compositeSubscription.dispose();
    super.dispose();
  }
}
